'***************   New Simple Archiver V101   ***************
' Purpose:
' NSA copies all selected files into a single file.
' This single file can easily be transferred via xmodem,
' the saved files can be unpacked with this program
' or - because it is not compressed - with an editor.
'
'      For  demonstration  only
'      Use  it on your own risk
'      2/2023 by Twofingers@TBS
'      for Picomites  and  CMM2
'      and  MMBasic for Windows
'
' Tested with:
' PicoMite (Flash drive "A:" + Teraterm)
' MMBasic PicoMiteWeb V5.09, MMB4W and CMM2 5.07.02
'
' Partially compatible with Epsilons@TBS "MAR" archiver
'
'*************************************************************
 Option explicit
 Option base 0

 Print "CPUSPEED: " MM.Info(CPUSPEED)

 Const VERSION$   ="101"
 Const TRUE       =1
 Const FALSE      =Not TRUE
 Const PressSpace$="PRESS ANY KEY to continue or <ESC> to cancel"+Chr$(13)

 Const EBSR%=60 ' Estimated base storage requirements per file to be archived
                 ' DIR:, ENDDIR:, ENDARCHIVE:, FILE:, FileName, FileLen
                 ' to calculate the required storage space (overhead)

 Const MMB4W = MM.Device$="MMBasic for Windows"
 Const DEBUG=FALSE
 If MMB4W Then
   Const Slash$="\"
 Else
   Const Slash$="/"
 EndIf

 Dim ADIR_NAME$ ="nsa" ' default target dir
 Dim AskText$
 Dim Job$
 Dim Confirm$
 Dim archiveName$
 Dim archiveTemp$
 Dim DirName$
 Dim FileName$="", FileMask$="*.bas"
 Dim ADir$
 Dim AFile$
 Dim AFileLen$
 Dim MDir$
 Dim MFile$
 Dim MFlen%
 Dim FileCount%=0
 Dim FileExists%,FIndex%
 Dim FSize%,TotalFSize%
 Dim FileNotFoundFlag%=FALSE

 If MM.Device$ = "WebMite" Then
   On error skip 1
   WEB ntp 1
 EndIf

 main

End '**********************  this is the END  ***********************


Sub main
  'CLS
  Print "Device: ";MM.Device$,Date$,Time$

  Print String$(55,"#")
  Print "             New Simple Archiver  NSA "+VERSION$
  Print String$(55,"#")

  Do
    If Not MMB4W Then
      Print
      Print "Bytes avail. on "+Chr$(34)+Cwd$+Chr$(34)+": ";MM.Info(FREE SPACE)
    EndIf
    Print
    Print "Enter"
    Print "'F' to extract ONE single (f)ile from an archive to CWD"
    Print "'L' to (l)ist files in an archive file"
    Print "'A' to (a)rchive selected files into an archive file"
    If Not MMB4W Then
      Print "'K' to (k)ill directories of files with content"
    EndIf
    Print "'E' to (e)xtract ALL archive files into a subdirectory"
    Print "'D' to show (d)irectory"
    Print

    Print "'C' to (c)hange directory"
    Print "'X' to E(X)IT"
'    If MM.Device$="Colour Maximite 2" Then
'      Do :Loop While keydown(1)=0
'    EndIf
    Input "Your choice? ", Confirm$
    If MMB4W Then Print ' for MMB4W
    Print

    Select Case UCase$(Confirm$)
      Case "A"
        do_ArchiveMain
      Case "E"
        do_Extract
      Case "F"
        do_FileExtract
      Case "D"
        do_ShowDirs
      Case "L"
        do_Arlist("list")
      Case "K"        ' intentionally disabled for MMB4W
        If MMB4W Then ' I don't trust MMBasic in Windows
            Print "Sorry, this is in MMB4W disabled!"
          Else
            do_KillDirs
        EndIf
    Case "C"
       do_chdir
    Case "X"
      Print " Bye!"
      Exit Sub
    End Select
  Loop
End Sub 'main


Sub do_ArchiveMain '*******************************************
 Local requiredDS%

 Job$="build"
 do_Get_archiveName
 If Instr(archiveName$,"*") Then
    Print " ****  user abort  ****"
    Print
    Exit Sub
 EndIf
 Do While Dir$(archiveName$, FILE)=archiveName$
    Print " "+archiveName$;
    Input " exist! Overwrite or New? (O/N) ",Confirm$
    If UCase$(Confirm$) = "O" Then
     ' because of case sensitivity in names for KILL:
      archiveTemp$ = Dir$(archiveName$, FILE)
      Kill archiveTemp$
    EndIf

    If UCase$(Confirm$) = "N" Then
         do_Get_archiveName
    EndIf
 Loop

 Print " Chosen archive name: "+archiveName$
 Input " FileMask? ",FileMask$
 Print String$(55,"-")
 TotalFSize%=0
 FileCount%=0
 FileName$ = Dir$(FileMask$, FILE)
 Do While FileName$ <> ""
    FSize% = MM.Info(FILESIZE FileName$)
    Inc TotalFSize%, FSize%
    Print Str$(FSize%,7), FileName$;
    Print
    FileName$ = Dir$()
    Inc FileCount%
 Loop

 requiredDS%=(Int((TotalFSize%+EBSR%*FileCount%)/4096)+1)*4096 'estimated
 Print FileCount% " file(s) to archive. Total: "Str$(TotalFSize%);
 Print "  ("+Str$(requiredDS%)+") Bytes --------"

 If Not MMB4W Then
   If requiredDS% > MM.Info(FREE SPACE) Then
     Print "****  Insuffizient disk space! Sorry!  ****"
     Exit Sub
   EndIf
 EndIf

 Print
 If FileCount% Then
   Print " Continue to archive these files? ";
   Input "Y/N ", Confirm$
   If UCase$(Confirm$) = "N" Then
     Print " Bye!"
     Exit Sub
   EndIf
   Do_ArchiveFiles '################
 Else
   Print " Nothing to archive!"
 EndIf

End Sub ' do_archiveMain ********************************


Sub Do_ArchiveFiles '
Local FileCount%=0
Local FIndex% = 1
Local ArName$
Local FileName$ = Dir$(FileMask$, FILE)

  On error skip 1
  Close #1

  Open archiveName$ For output As #1
  If Len(getdn$()) Then 'not root
    ArName$=getdn$() 'get dir name
  Else
    ArName$=ADIR_NAME$ '"NSA"
  EndIf

  Print #1,"DIR: "+ArName$

  Do
    do_Appendfile(FileName$)
    Print Str$(FIndex%,4,0)+"  "+FileName$
    FileName$ = Dir$()
    If FileName$ = archiveName$ Then FileName$ = Dir$()
    Inc FIndex%
  Loop Until FileName$ = ""

  Print #1,"ENDDIR: "+ArName$
  Print #1,"ENDARCHIVE:"         'for compatibility with MAR archiver
  Print #1
  Close #1

  Print String$(55,"=")
  Print  (FIndex%-1) " Files added to ";
  Print  archiveName$,Str$(MM.Info(FILESIZE archiveName$),7) " Bytes"

End Sub '******* Do_ArchiveFiles  *******************************


Sub do_AppendFile(FileN$) 'Sub for Sub: Do_ArchiveFiles
Local f_pos%
Local ch1, ch2
Const CH_SIZE=255

  Open FileN$ For input As #2
  Print #1,"FILE: "+FileN$
  Print #1,MM.Info(FILESIZE FileN$)

  ch1=Int(MM.Info(FILESIZE FileN$)/CH_SIZE)
  ch2=MM.Info(FILESIZE FileN$) Mod CH_SIZE

  Do While ch1>=0
    On ERROR SKIP 1
    If ch2 Then Print #1, Input$(ch2,#2);
    If MM.Errno<>0 Then
      Print "Error: ";MM.ErrMsg$
      Close #1,#2
      End
    EndIf

    If f_pos% >= 10000 Then Print "#";f_pos%;Chr$(13);

    Inc f_pos%,ch2
    ch2=255
    Inc ch1,-1
  Loop

  Close #2
  If MM.Errno = 0 Then
    'Print "File: " + FileN$ + " successfully appended!"
    Inc FileCount%
  Else
     Print "ERROR @ File: "+ FileN$+" "+MM.ErrMsg$
  EndIf
End Sub '**************** do_AppendFile  *************************


Sub do_Extract ' Extract all archive files into a new created directory
               ' the archive contains the name of the target directory
 Local path$
 Local integer i, requiredDS% ' required disk space
 Local f_pos%
 Local integer ch1, ch2
 Const CH_SIZE=255

 Job$="extract"
 AskText$=" Please enter a new name for a target directory. ("
 AskText$=AskText$+Chr$(34)+"*"+Chr$(34)+" to end) "

 Do
    do_Get_archiveName
    If Instr(archiveName$,"*") Then
      Print " ****  user abort  ****"
      Print
      Exit Sub
    EndIf
    If Dir$(archiveName$, FILE) = "") Then
        Print " ****  File "+archiveName$+" not found!  ****"
    Else
        Exit
    EndIf
 Loop

 ' Calculate required disk space (Flash drive)
 ' each file needs at least 4096 bytes +
 ' each directory needs at least 2*4096 bytes
 ' 8192+(int(FileSize/4096)+1)*4096

 requiredDS%=getFileSize%(archiveName$)+8192

 If Not MMB4W Then
   If MM.Info(FREE SPACE) < requiredDS% Then
      Print "Error: Not enough disk space!  Avail.: "MM.Info(FREE SPACE);
      Print "  required: "requiredDS%
      Exit Sub
   EndIf
 EndIf

 On error skip 1
 Close #1
 Open archiveName$ For input As #1

 Line Input #1,ADir$
 MDir$ =Mid$(ADir$,6)
 Print

 Do
    If Dir$(MDir$, Dir) = MDir$ Then
      Print " Target directory "+Chr$(34)+MDir$+Chr$(34)+" exists."
      Line Input AskText$,MDir$
    ElseIf MDir$="" Then
      Line Input AskText$,MDir$
    EndIf
    If MDir$ = "." Or Instr(MDir$,"*") Then Exit Sub
    On error skip 1
    Mkdir Mdir$
 Loop While MM.Errno<>0 Or MDir$=""

 Print
 Print " Directory "+Chr$(34)+Cwd$+"/"+Mdir$+Chr$(34)+" created!"
 Print " Archive: "+Chr$(34)+archiveName$+Chr$(34)+" extracting ..."

 Do
    Line Input #1,AFile$
    Line Input #1,AFileLen$

    MFile$=Mid$(AFile$,7)
    MFlen%=Val(AFileLen$)

    If Left$(AFile$,7)="ENDDIR:" Or MFile$="" Then Exit
    Print ">"+Left$(AFile$+Space$(30),30)+AFileLen$
    path$="./"+Mdir$+"/"+MFile$

    On error skip 1
    Open path$ For output As #2
    If MM.Errno<>0 Then Print MM.ErrMsg$:Exit Sub

    ch1=Int(MFlen%/CH_SIZE)
    ch2=MFlen% Mod CH_SIZE
    f_pos%=0

    Do While ch1>=0
      On ERROR SKIP 1
      If ch2 Then Print #2, Input$(ch2,#1);
      If MM.Errno<>0 Then
        Print "Error: ";MM.ErrMsg$
        Close #1,#2
        End
      EndIf

      If f_pos% >= 10000 Then Print "#";f_pos%;Chr$(13);

      Inc f_pos%,ch2
      ch2=CH_SIZE
      Inc ch1,-1
    Loop

    Close #2
 Loop Until Eof(#1)
 Close #1
 Print " ****  finished!  ****"
End Sub '  do_Extract  ********************************


Sub do_ShowDirs ' kind of "files"
 Local FName$, DirName$,a$,FileMask$, Key$
 Local FCounter%=0, PageHeight%=10
 Local Ftotal%=0

  Input "Filemask (Enter = '*')? ", FileMask$
  If FileMask$="" Then FileMask$="*"
  Print " "  Cwd$
  Print "-----------------   Show directory   ------------------"
  DirName$= Dir$("*", Dir)'.

  Do While DirName$ <> ""
    Print "   <DIR>  "DirName$
    DirName$=Dir$()
  Loop
  FName$= Dir$(FileMask$, FILE)

  Do While FName$ <> ""
    Inc Ftotal%,MM.Info(FILESIZE FName$)
    a$= Left$("   "+FName$+Space$(39),39)
    Print a$;Str$(MM.Info(FILESIZE FName$),8);"       "
    FName$=Dir$()

    If FCounter%=PageHeight% Then
       Print PressSpace$;
       Do :Key$=Inkey$:Loop While Key$="" And Key$<>Chr$(27)
       If Key$=Chr$(27) Then Exit
       FCounter%=0
    EndIf
    Inc FCounter%
  Loop

  Print "-----------------------------------------------"
  Print Space$(22)+"Total: "+Str$(Ftotal%,12)" Bytes"
  If Not MMB4W Then
     Print Space$(22)+"Avail: "+Str$(MM.Info(FREE SPACE),12)" Bytes"
  EndIf

Exit Sub  'do_ShowDirs ***************************


Sub do_FileExtract ' extract on single file of an archive
Const CH_SIZE = 255

Local ch1,ch2 As integer
Local dummy$
Local ADir$
Local outfile$,NewOutFile$=""
Local exfile$=""
Local yn$,ln$
Local requiredDS%
Local f_pos%,File_ptr%
Local wild$=" Wildcards ('*','?') are not allowed! "
Local wl%=Len(wild$), wc$=String$(29-wl%/2,"-")

  do_ArList("extract") 'List the content of an archive
  If FileNotFoundFlag% Then Exit Sub

  ln$=String$(15-Len(archiveName$)/2,"-")

  Print
  Print ln$+"   Extract one file from "archiveName$+"  "+ln$
  Print wc$+wild$+wc$
  Print

  Do            'test if exfile$ exist in CWD?
    yn$="y"
    Input " File to extract? (<Enter> for exit) ", exfile$
    If exfile$="" Then
      Print "-------------------- canceled by user --------------------"
      Exit Sub
    EndIf

    If Instr(exfile$,"*") Or Instr(exfile$,"?") Then
     Print wc$+wild$+wc$
     Print "-------------------- canceled by user --------------------"
      Exit Sub
    EndIf

    If Dir$(exfile$, FILE)=exfile$ Then ' files exist in CWD
       Print " "+exfile$+" exist in "+Cwd$+", overwrite? <y>/<n>ew ";
       Input yn$
       yn$=LCase$(yn$)
    Else
       Exit
    EndIf

    If yn$ = "n" Then 'new file
      Do
        Print " New file name for",exfile$+"? (* = exit)";
        Input NewOutFile$
        If NewOutFile$="*" Then Exit Sub
        If Dir$(NewOutFile$, FILE)=NewOutFile$ Then ' files exist in CWD
           Print " "+NewOutFile$+" exist in "+Cwd$
        EndIf
      Loop Until Dir$(NewOutFile$, FILE) = ""
      Exit
    EndIf
  Loop Until yn$ = "y" Or (Dir$(exfile$, FILE) = "")

' each file needs at least 4096 bytes (on Picomite A:)
' (int(FileSize/4096)+1)*4096
  requiredDS%=getFileSize%(archiveName$, exfile$)
  If Not MMB4W Then
    If  MM.Info(FREE SPACE)< requiredDS% Then
      Print " Error: Not enough disk space! Required: "requiredDS%
      Exit Sub
    EndIf
  EndIf
  On error skip 2
  Close #1
  Open archiveName$ For input As #1

  If MM.Errno<>0 And MM.Errno<>16 Then ' errno 16 = false 'file not open'
     Print MM.ErrMsg$: Exit Sub
  EndIf

  Line Input #1,ADir$
  f_pos% = 0
  Do
    Line Input #1,AFile$
    outfile$=Mid$(AFile$,7)
    If Left$(AFile$,7)="ENDDIR:" Or AFile$="" Then Exit

    Line Input #1,AFileLen$
    MFlen%=Val(AFileLen$)
    ch1=Int(MFlen%/CH_SIZE)
    ch2=MFlen% Mod CH_SIZE

    If outfile$ = exfile$ Then ' found the file
       If NewOutFile$<>"" And outfile$<>NewOutFile$ Then
          outfile$=NewOutFile$
       EndIf
       Open outfile$ For output As #2
       Do While ch1>=0
         If ch2 Then Print #2, Input$(ch2,#1); 'no 0 len file
         If MM.Errno<>0 And MM.Errno<>16 Then
           Print MM.ErrMsg$
           Exit Sub
         EndIf
         If f_pos% >= 10000 Then Print "#";f_pos%;Chr$(13);
         Inc f_pos%,ch2
         ch2=CH_SIZE
         Inc ch1,-1
       Loop

       Print " "+AFile$+" successfully as "+outfile$+" extracted."
       Print
       Print String$(55,"-")
       On error skip 1
       Close #2
       Exit Sub
    Else           ' skip files
       File_ptr% = Loc(#1)+MFlen%
       Seek #1,File_ptr%  ' set the file pointer to next file
    EndIf
  Loop
  Print
  Print " Error! File: "+Chr$(34)+exfile$+Chr$(34)+" not found in archive ";
  Print Chr$(34)+archiveName$+Chr$(34)
  Print String$(55,"-")
  On error skip 1
  Close #1, #2

End Sub '--------------  do_FileExtract ----------------------------


' get the FileSize of one single file (FN$) in an archive
' or all files if FN$=""
Function getFileSize%(archiveName$, FN$) As integer
 Const CH_SIZE = 255
 Local dummy$
 Local ADir$
 Local integer ch1,ch2,File_ptr%

  getFileSize%=0

  On error skip 2
  Close #1
  Open archiveName$ For input  As #1 '

  If MM.Errno<>0 And MM.Errno<>16 Then ' errno 16 = false file not open
     Print MM.ErrMsg$: Exit Sub
  EndIf

  Line Input #1,ADir$

  Do
    Line Input #1,AFile$

    If Left$(AFile$,7)="ENDDIR:" Or AFile$="" Then Exit

    Line Input #1,AFileLen$
    MFile$=Mid$(AFile$,7)
    MFlen%=Val(AFileLen$)

    Select Case FN$
      Case ""            'for all files
        Inc getFileSize%,(Int(MFlen%/4096)+1)*4096
      Case Else          ' for one single file
        If FN$ = MFile$ Then
            getFileSize%=(Int(MFlen%/4096)+1)*4096
            Exit Function
        EndIf
    End Select

    File_ptr% = Loc(#1)+MFlen%
    Seek #1,File_ptr%

  Loop
  Close #1
End Function '-------------- getFileSize% --------------------


Sub do_ArList(MyJob$) As integer 'List the content of an archive
Const CH_SIZE = 255
Local integer Ch1,Ch2
Local dummy$
Local ADir$
Local integer FCounter%=0, PageHeight=18
Local File_ptr%
Local key$
Local reqDS%

 FileNotFoundFlag%=FALSE
 Job$=MyJob$

  do_Get_archiveName
  If Instr(archiveName$,"*") Then
    Print " ****  user abort  ****"
    Print
    FileNotFoundFlag%=TRUE
    Exit Sub
  ElseIf MM.Info(FILESIZE archiveName$)=-1 Then
    Print " Oops! "+archiveName$+" not found in "+Cwd$
    FileNotFoundFlag%=TRUE
    Exit Sub
  EndIf

  reqDS%=getFileSize%(archiveName$)+8192

  On error skip 2
  Close #1
  Open archiveName$ For input As #1
  If MM.Errno<>0 And MM.Errno<>16 Then ' errno 16 = false file not open
'  If MM.Errno<>0 Then
     Print MM.ErrMsg$: Exit Sub
  EndIf

  Print
  Print " Content of: " archiveName$+" (";
  Print Str$(MM.Info(FILESIZE archiveName$),0)")";
  Print "  "reqDS% " bytes (unpacked)"
  Print String$(55,"-")
  Line Input #1,ADir$    'DIR: nsa
  Print "Target: ";
  Print ADir$

  Do
    Line Input #1,AFile$
    If Left$(AFile$,7)="ENDDIR:" Or AFile$="" Then Exit
    Line Input #1,AFileLen$
    MFile$=Mid$(AFile$,7)
    MFlen%=Val(AFileLen$)

    File_ptr% = Loc(#1)+MFlen%
    Seek #1,File_ptr%

    Print Left$("   "+MFile$+Space$(40),40),Str$(MFlen%,7);"       "

    If FCounter%=PageHeight Then
       Print PressSpace$;
'       Do :Key$=Inkey$:Loop While Key$="" And Key$<>Chr$(27)
       'for CMM2:
       Do :key$=Inkey$ :Loop Until Asc(Key$) >31 Or Key$=Chr$(27) Or Key$=Chr$(13)
       Print Space$(50)+Chr$(13);
       If Key$=Chr$(27) Then Exit
    EndIf
    Inc FCounter%

  Loop
  Close #1
End Sub '-------------------- do_ArList  -----------------------


Sub  do_KillDirs ' kills a directory including contents. Not working with MMB4W!
Local DirName$
Local FileMask$
Local FName$
Local DCount%,delDirPos%

 Print Cwd$
 Do
   DirName$= Dir$("*", Dir)
   DCount%=1
   Do While DirName$ = "." Or DirName$ = ".."
      DirName$ = Dir$()
   Loop
   If DirName$="" Then
     Print "** There is no directory to delete. Bye! **"
     Print "*******************************************"
     Exit Sub
   EndIf
   Do
     Print ">"+Left$(DirName$+"<"+"   "+FName$+Space$(30),30);
     Input " kill? (y/n or e(x)it) ",Confirm$

     If MMB4W Then Print

     Select Case LCase$(Confirm$)
     Case "y"
        FileMask$="./"+DirName$+"/*"
        fname$= Dir$(FileMask$, FILE)
        Print
        Print "Processing ... "
        Do
          If DirName$="" Or fname$="" Then Exit
          On error skip 1
          Kill "./"+DirName$+"/"+fname$
          If MM.Errno<>0 Then
              Print MM.ErrMsg$: Exit Sub
          Else
              Print Left$("./"+DirName$+"/"+FName$+Space$(30),30);
              Print " deleted"
          EndIf
          fname$= Dir$()
        Loop  While fname$<>""

        On error skip 1
        Rmdir DirName$

        delDirPos%=DCount% ' remember the removed Dir position
        If MM.Errno<>0 Then
          Print MM.ErrMsg$
          DirName$ = Dir$()
          Inc DCount%
          Exit 'do
        Else
          Print "Directory >"+Left$(DirName$+"<"+Space$(20),20)+"removed"
          Print
          DirName$= Dir$("*", Dir)
          DCount%=1

          Do While DirName$ = "." Or DirName$ = ".."
             DirName$ = Dir$()
          Loop

          Do While delDirPos% -1
             DirName$ = Dir$() ' skip dirs that have already been processed
             Inc DCount%
             Inc delDirPos%,-1
          Loop

          If DirName$="" Then
            Print "****  No (more) Dir to delete. Bye!  ****"
            Print "*****************************************"
            Exit Sub
          EndIf
        EndIf
    Case "x"
      Print " ****  user abort  ****"
      Print
      Exit Sub
    Case Else
      DirName$ = Dir$()
      Inc DCount%
      If DirName$="" Then
         Print
         Print "** No more directories to delete. Bye! **"
         Print "*****************************************"
         Exit Sub
      EndIf
    End Select
   Loop
 Loop
End Sub 'do_KillDirs  ***********************************


Sub  do_chDir ' changes the active directory (debug and testing)
Local DirName$
Local FileMask$
Local FName$
Local DCount%,delDirPos%

 Print Cwd$

 If Mid$(Cwd$,3) <> "/" Then ' if not in root
   DirName$= ".."

   Print ">"+Left$(DirName$+"<"+"   "+FName$+Space$(30),30);
   Input " Chdir? (y/n or e(x)it) ",Confirm$

   Select Case LCase$(Confirm$)
   Case "y"
      On error skip 1
      Chdir DirName$
      Print
      Print " You are now here: "Cwd$
      Print "*******************************"
      Exit Sub
   Case "x"
      Print
      Print " ****  user abort  ****"
      Print
      Exit Sub
   End Select
 EndIf

 Do
   DirName$= Dir$("*", Dir)

   If DirName$="" Then
      Print "** There is no directory to change to. Bye! **"
      Print "**********************************************"
      Exit Sub
   EndIf

   Do
     Print ">"+Left$(DirName$+"<"+"   "+FName$+Space$(30),30);
     Input " Chdir? (y/n or e(x)it) ",Confirm$

     Select Case LCase$(Confirm$)
       Case "y"
       On error skip 1
       Chdir DirName$
       Print
       Print " You are now here: "Cwd$
       Print "*******************************"
       Exit Sub
     Case "x"
       Print
       Print " ****  user abort  ****"
       Print
       Exit Sub
     Case Else
       DirName$= Dir$()
       If DirName$= "" Then
          Print
          Print "** No more directories. Bye! **"
          Print "*******************************"
          Exit Sub
       EndIf
     End Select
   Loop
 Loop
End Sub 'do_chdir ***********************************


Sub do_Get_archiveName
Local AskText$=" Archive file to "+Job$
Local AN$

  Do
    Print AskText$
    Print " ('*' = exit // [Extention '.nsa' will be added])";
    Input archiveName$
    AN$=Right$(archiveName$,4)
    If MMB4W Then Print ' for MMB4W
  Loop While archiveName$ = ""

  If AN$ <> ".nsa" And AN$ <> ".mar" And AN$ <> ".sfa" Then
    archiveName$=archiveName$+".nsa"
  EndIf
End Sub 'do_Get_archiveName ******************************


Function getdn$() As string 'name of current folder
Local nlen=Len(Cwd$)
  Do While Mid$(Cwd$,nlen,1)<>Slash$ '"/", or "\" for MMB4W
    Inc nlen,-1
  Loop
  getdn$=Mid$(Cwd$,nlen+1)
End Function